'use strict';

let flashcards = [];
let currentCard = 0;
let startTime;
let correctAnswers = 0;
let timerInterval;

// gets name and number of questions  ||  hides and unhides the first and second page  ||  does stuff with equations
function startQuiz() {
    const name = document.getElementById('Name').value;
    const numQuestions = parseInt(document.getElementById('NumOfQuestion').value);
    const equations = document.getElementById('Question_Type').value;

    if (!name || isNaN(numQuestions) || numQuestions <= 0 || equations === 'default') {
        alert('Enter valid details.');
        return;
    }

    document.getElementById('Firstpage').classList.add('hidden');
    document.getElementById('Secondpage').classList.remove('hidden');
    document.getElementById('ResultName').innerText = name;

    flashcards = [];
    currentCard = 0;
    correctAnswers = 0;
    startTime = Date.now();
    timerInterval = setInterval(updateTimer, 1000);

    // displays the equations and gets the random numbers
    for (let i = 0; i < numQuestions; i++) {
        const num1 = Math.floor(Math.random() * 10) + 1;
        const num2 = Math.floor(Math.random() * 10) + 1;
        let question, answer;

        switch (equations) {
            case 'addition':
                question = `${num1} + ${num2}`;
                answer = num1 + num2;
                break;
            case 'subtraction':
                question = `${num1} - ${num2}`;
                answer = num1 - num2;
                break;
            case 'multiplication':
                question = `${num1} * ${num2}`;
                answer = num1 * num2;
                break;
            case 'division':
                const dividend = num1 * num2;
                question = `${dividend} / ${num1}`;
                answer = num2;
                break;
        }
        flashcards.push({ question, answer });
    }
    updateCard();
}

// changes the flash card and ends the quiz
function updateCard() {
    if (currentCard < flashcards.length) {
        document.getElementById('QuestionNum').innerText = `Question ${currentCard + 1}/${flashcards.length}`;
        document.getElementById('MathEquation').innerText = flashcards[currentCard].question;
        document.getElementById('Math_Question').value = '';
    } else {
        endQuiz();
    }
}

// checks if the answer is right and alerts the one takeing the test
function Next_Flashcards() {
    const userAnswer = parseFloat(document.getElementById('Math_Question').value);
    if (userAnswer === flashcards[currentCard].answer) {
        correctAnswers++;
        console.log('Right answer');
        alert('Right answer');
        // document.getElementById('Right_Wrong').innerText = 'Right'
    } else {
        console.log('Wrong answer');
        alert('Wrong answer');
        // document.getElementById('Right_Wrong').innerText = 'Wrong'
    }
    currentCard++;
    updateCard();
}

// changes the content on the result page  ||  hides the second page and shows the thirdpage
function endQuiz() {
    clearInterval(timerInterval);
    document.getElementById('Secondpage').classList.add('hidden');
    document.getElementById('Thirdpage').classList.remove('hidden');
    const totalTime = Math.floor((Date.now() - startTime) / 1000);
    document.getElementById('Time').innerText = new Date(totalTime * 1000).toISOString().substr(11, 8);
    document.getElementById('Date').innerText = new Date().toLocaleDateString();
    document.getElementById('Right').innerText = correctAnswers;
    document.getElementById('Wrong').innerText = flashcards.length - correctAnswers;
    document.getElementById('Percent').innerText = ((correctAnswers / flashcards.length) * 100).toFixed(1) + '%';
}

// updaes the time
function updateTimer() {
    const runningTime = Math.floor((Date.now() - startTime) / 1000);
    document.getElementById('Timer').innerText = new Date(runningTime * 1000).toISOString().substr(11, 8);
}

// resets the questions and the type of questons to their defualt value  ||  hides the third page and shows the first page
function redo() {
    document.getElementById('Firstpage').classList.remove('hidden');
    document.getElementById('Thirdpage').classList.add('hidden');
    document.getElementById('NumOfQuestion').value = '';
    document.getElementById('Question_Type').value = 'default';
}
